package handler

import (
	"github.com/sirupsen/logrus"
	"youngee_b_api/consts"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
	"youngee_b_api/util"

	"github.com/gin-gonic/gin"
)

func WrapCreateEnterpriseHandler(ctx *gin.Context) {
	handler := newCreateEnterpriseHandler(ctx)
	baseRun(handler)
}

func newCreateEnterpriseHandler(ctx *gin.Context) *CreateEnterpriseHandler {
	return &CreateEnterpriseHandler{
		req:  http_model.NewCreateEnterpriseRequest(),
		resp: http_model.NewCreateEnterpriseResponse(),
		ctx:  ctx,
	}
}

type CreateEnterpriseHandler struct {
	req  *http_model.CreateEnterpriseRequest
	resp *http_model.CommonResponse
	ctx  *gin.Context
}

func (h *CreateEnterpriseHandler) getRequest() interface{} {
	return h.req
}
func (h *CreateEnterpriseHandler) getContext() *gin.Context {
	return h.ctx
}
func (h *CreateEnterpriseHandler) getResponse() interface{} {
	return h.resp
}
func (h *CreateEnterpriseHandler) run() {
	//判断验证码是否正确

	//若正确，创建企业用户
	data := http_model.CreateEnterpriseRequest{}
	data = *h.req
	res, err := service.CreateEnterprise.CreateEnterpriseUser(h.ctx, data)
	if err != nil {
		logrus.Errorf("[CreateEnterpriseHandler] call CreateEnterpriseUser err:%+v\n", err)
		util.HandlerPackErrorResp(h.resp, consts.ErrorInternal)
		return
	}
	h.resp.Data = res
}
func (h *CreateEnterpriseHandler) checkParam() error {
	return nil
}
